aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/mvebu/cortexa9/base-files/lib
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/mvebu/cortexa9/base-files/lib')
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac46
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg37
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh98
-rwxr-xr-xtarget/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh59
4 files changed, 240 insertions, 0 deletions
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac b/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac
new file mode 100644
index 0000000000..fd41836c8d
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac
@@ -0,0 +1,46 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_set_mac_address() {
+ local mac
+
+ . /lib/functions.sh
+
+ case $(board_name) in
+ linksys,caiman|linksys,cobra|linksys,rango|linksys,shelby|linksys,venom)
+ # rename interfaces back to the way they were with 4.4
+ case "$(readlink /sys/class/net/eth0)" in
+ *f1070000*)
+ ip link set eth0 name tmp0
+ ip link set eth1 name eth0
+ ip link set tmp0 name eth1
+ ;;
+ esac
+
+ mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+ mac_wan=$(macaddr_setbit_la "$mac")
+ ip link set dev eth0 address $mac 2>/dev/null
+ ip link set dev eth1 address $mac_wan 2>/dev/null
+ ;;
+ linksys,mamba)
+ mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+ ip link set dev eth0 address $mac 2>/dev/null
+ ip link set dev eth1 address $mac 2>/dev/null
+ ;;
+ marvell,a385-db-ap|solidrun,clearfog*a1)
+ # rename interfaces back to the way they were with 4.4
+ case "$(readlink /sys/class/net/eth0)" in
+ *f1070000*)
+ ip link set eth0 name tmp0
+ ip link set eth1 name eth0
+ ip link set eth2 name eth1
+ ip link set tmp0 name eth2
+ ;;
+ esac
+ ;;
+ esac
+}
+
+boot_hook_add preinit_main preinit_set_mac_address
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg b/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg
new file mode 100644
index 0000000000..83448e5ace
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg
@@ -0,0 +1,37 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_mount_syscfg() {
+ . /lib/functions.sh
+ . /lib/upgrade/common.sh
+
+ case $(board_name) in
+ linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
+ needs_recovery=0
+ syscfg_part=$(grep syscfg /proc/mtd |cut -c4)
+ ubiattach -m $syscfg_part || needs_recovery=1
+ if [ $needs_recovery -eq 1 ]
+ then
+ echo "ubifs syscfg partition is damaged, reformatting"
+ ubidetach -m $syscfg_part
+ ubiformat -y -O 2048 -q /dev/mtd$syscfg_part
+ ubiattach -m $syscfg_part
+ ubimkvol /dev/ubi1 -n 0 -N syscfg -t dynamic --maxavsize
+ fi
+ mkdir /tmp/syscfg
+ mount -t ubifs ubi1:syscfg /tmp/syscfg
+ [ -f "/tmp/syscfg/$BACKUP_FILE" ] && {
+ echo "- config restore -"
+ cd /
+ mv "/tmp/syscfg/$BACKUP_FILE" /tmp
+ tar xzf "/tmp/$BACKUP_FILE"
+ rm -f "/tmp/$BACKUP_FILE"
+ sync
+ }
+ ;;
+ esac
+}
+
+boot_hook_add preinit_main preinit_mount_syscfg
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
new file mode 100644
index 0000000000..6ccfdd0768
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
@@ -0,0 +1,98 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+#
+
+linksys_get_target_firmware() {
+
+ local cur_boot_part mtd_ubi0
+
+ cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
+ if [ -z "${cur_boot_part}" ] ; then
+ mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
+ case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
+ kernel1|rootfs1)
+ cur_boot_part=1
+ ;;
+ kernel2|rootfs2)
+ cur_boot_part=2
+ ;;
+ esac
+ >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
+ "${cur_boot_part}" "${mtd_ubi0}"
+ fi
+
+ case $cur_boot_part in
+ 1)
+ fw_setenv -s - <<-EOF
+ boot_part 2
+ bootcmd "run altnandboot"
+ EOF
+ printf "kernel2"
+ return
+ ;;
+ 2)
+ fw_setenv -s - <<-EOF
+ boot_part 1
+ bootcmd "run nandboot"
+ EOF
+ printf "kernel1"
+ return
+ ;;
+ *)
+ return
+ ;;
+ esac
+}
+
+linksys_get_root_magic() {
+ (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+ local magic_long="$(get_magic_long "$1")"
+
+ mkdir -p /var/lock
+ local part_label="$(linksys_get_target_firmware)"
+ touch /var/lock/fw_printenv.lock
+
+ if [ ! -n "$part_label" ]
+ then
+ echo "cannot find target partition"
+ exit 1
+ fi
+
+ local target_mtd=$(find_mtd_part $part_label)
+
+ [ "$magic_long" = "73797375" ] && {
+ CI_KERNPART="$part_label"
+ if [ "$part_label" = "kernel1" ]
+ then
+ CI_UBIPART="rootfs1"
+ else
+ CI_UBIPART="rootfs2"
+ fi
+
+ nand_upgrade_tar "$1"
+ }
+ [ "$magic_long" = "27051956" -o "$magic_long" = "0000a0e1" ] && {
+ # check firmwares' rootfs types
+ local target_mtd=$(find_mtd_part $part_label)
+ local oldroot="$(linksys_get_root_magic $target_mtd)"
+ local newroot="$(linksys_get_root_magic "$1")"
+
+ if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
+ # we're upgrading from a firmware with UBI to one with UBI
+ then
+ # erase everything to be safe
+ mtd erase $part_label
+ get_image "$1" | mtd -n write - $part_label
+ else
+ get_image "$1" | mtd write - $part_label
+ fi
+ }
+}
+
+platform_copy_config_linksys() {
+ cp -f "$UPGRADE_BACKUP" "/tmp/syscfg/$BACKUP_FILE"
+ sync
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh
new file mode 100755
index 0000000000..8baed969a3
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,59 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+REQUIRE_IMAGE_METADATA=1
+
+platform_check_image() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_check_image_sdcard "$1"
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+}
+
+platform_do_upgrade() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_do_upgrade_sdcard "$1"
+ ;;
+ linksys,caiman|\
+ linksys,cobra|\
+ linksys,mamba|\
+ linksys,rango|\
+ linksys,shelby|\
+ linksys,venom)
+ platform_do_upgrade_linksys "$1"
+ ;;
+ *)
+ default_do_upgrade "$1"
+ ;;
+ esac
+}
+platform_copy_config() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_copy_config_sdcard
+ ;;
+ linksys,caiman|\
+ linksys,cobra|\
+ linksys,mamba|\
+ linksys,rango|\
+ linksys,shelby|\
+ linksys,venom)
+ platform_copy_config_linksys
+ ;;
+ esac
+}